
local _SavePending, _Save, evt = false, {}, nil

-- InCombatLockdown()

local function round(num, idp) return tonumber(string.format("%." .. (idp or 0) .. "f", num)) end



local mnuitems = {}


local function SaveValues(c)
 if c then _Save[c.name] = true end
 if InCombatLockdown() then _SavePending = true return true end
 local cfg = SkyUI.Config

 if _Save["cHud"] then if mnuitems.cHud:GetChecked() then SkyUI.Modules.UnitFrames.Disable() else SkyUI.Modules.UnitFrames.Enable() end end
 if _Save["cActionBars"] then if mnuitems.cActionBars:GetChecked() then SkyUI.Modules.ActionBars.Disable() else SkyUI.Modules.ActionBars.Enable() end end
 
 if _Save["cFocus"] then SkyUI.Config.UnitFrames.focus.Enabled = mnuitems.cFocus:GetChecked() end
 if _Save["cPet"] then SkyUI.Config.UnitFrames.playerpet.Enabled = mnuitems.cPet:GetChecked() end
 if _Save["cPetTarget"] then SkyUI.Config.UnitFrames.playerpettarget.Enabled = mnuitems.cPetTarget:GetChecked() end
 if _Save["cTargetTarget"] then SkyUI.Config.UnitFrames.targettarget.Enabled = mnuitems.cTargetTarget:GetChecked() end
 if _Save["cTargetPet"] then SkyUI.Config.UnitFrames.targetpet.Enabled = mnuitems.cTargetPet:GetChecked() end
 if _Save["cTargetPetTarget"] then SkyUI.Config.UnitFrames.targetpettarget.Enabled = mnuitems.cTargetPetTarget:GetChecked() end

 if _Save["HorzOffset"] then SkyUI.Config.UnitFrames.UI.OffsetX = round(mnuitems.HorzOffset:GetValue()) end
 if _Save["VertOffset"] then SkyUI.Config.UnitFrames.UI.OffsetY = round(mnuitems.VertOffset:GetValue()) end


 if _Save["cMacroText"] then SkyUI.Config.ActionBars.UI.MacroText = mnuitems.cMacroText:GetChecked()
  SkyUI.Modules.ActionBars.ToggleMacroText(not SkyUI.Config.ActionBars.UI.MacroText) end
 if _Save["cHotKeys"] then SkyUI.Config.ActionBars.UI.HotKeys = mnuitems.cHotKeys:GetChecked()
  SkyUI.Modules.ActionBars.ToggleHotKeys(not SkyUI.Config.ActionBars.UI.HotKeys) end
 if _Save["cItemCount"] then SkyUI.Config.ActionBars.UI.ItemCount = mnuitems.cItemCount:GetChecked()
  SkyUI.Modules.ActionBars.ToggleItemCounts(not SkyUI.Config.ActionBars.UI.ItemCount) end

 if _Save["cGCD"] then SkyUI.Config.ActionBars.UI.ShowGCD = mnuitems.cGCD:GetChecked() end

 if _Save["cKeyPad"] then SkyUI.Config.ActionBars.KeyPad.Enabled = mnuitems.cKeyPad:GetChecked() SkyUI.Modules.ActionBars.ToggleBar("KeyPad", mnuitems.cKeyPad:GetChecked()) end
 if _Save["cArrowPad"] then SkyUI.Config.ActionBars.ArrowPad.Enabled = mnuitems.cArrowPad:GetChecked() SkyUI.Modules.ActionBars.ToggleBar("ArrowPad", mnuitems.cArrowPad:GetChecked()) end
 if _Save["cVertBar"] then SkyUI.Config.ActionBars.VertBar.Enabled = mnuitems.cVertBar:GetChecked() SkyUI.Modules.ActionBars.ToggleBar("VertBar", mnuitems.cVertBar:GetChecked()) end
 if _Save["cMainBar"] then SkyUI.Config.ActionBars.MainBar.Enabled = mnuitems.cMainBar:GetChecked() SkyUI.Modules.ActionBars.ToggleBar("MainBar", mnuitems.cMainBar:GetChecked()) end
 if _Save["cMicroMenu"] then SkyUI.Config.ActionBars.MicroMenu.Enabled = mnuitems.cMicroMenu:GetChecked() SkyUI.Modules.ActionBars.ToggleBar("MicroMenu", mnuitems.cMicroMenu:GetChecked()) end
 if _Save["cPetBar"] then SkyUI.Config.ActionBars.PetBar.Enabled = mnuitems.cPetBar:GetChecked() SkyUI.Modules.ActionBars.ToggleBar("PetBar", mnuitems.cPetBar:GetChecked()) end




-- print(mnuitems.cItemCounts:GetChecked())

 SkyUI.Modules.Main:OnConfigUpdated()
 _SavePending = false
 _Save = {}
end

local function PlaceCheckBox(mnu, x, y, rt, name, txt)
 local f = CreateFrame("CheckButton", "cfg" .. name, mnu, "UICheckButtonTemplate")
 mnuitems[name] = f
 f.name = name
 f:ClearAllPoints()

--*TOPLEFT  *TOP  *TOPRIGHT
--LEFT    CENTER   RIGHT
--*BTMLEFT  *BTM  *BTMRIGHT

 if rt == "TOPLEFT" or rt == "TOP" or rt == "TOPRIGHT" then y = -y - 30 elseif rt == "BOTTOMLEFT" or rt == "BOTTOM" or rt == "BOTTOMRIGHT" then  y = y + 55 end
 if rt == "TOPLEFT" or rt == "LEFT" or rt == "BOTTOMLEFT" then x = x + 25 elseif rt == "TOPRIGHT" or rt == "RIGHT" or rt == "BOTTOMRIGHT" then x = x - 25 end
 f:SetPoint(rt, x, y)
 
 f:SetSize(25, 25)
 _G["cfg" .. name .. "Text"]:SetText(" " .. txt)
 _G["cfg" .. name .. "Text"]:SetFontObject(GameFontNormal)
 _G["cfg" .. name .. "Text"]:SetPoint("LEFT", 23, 1)
-- MakeMovable(frame)
 f:SetScript("OnClick", SaveValues)
end


local function Slider_ValueChanged(this)
 mnuitems[this._EditBox]:SetText(round(this:GetValue()))
 SaveValues(this)
end

local function PlaceSlider(mnu, x, y, rt, name, txt, min, max, val, default, editbox)

 local f = CreateFrame("Slider", "cfg" .. name, mnu, "OptionsSliderTemplate")

 mnuitems[name] = f
 f.name = name

 if not val then val = default end

 f:ClearAllPoints()
 
 if rt == "TOPLEFT" or rt == "TOP" or rt == "TOPRIGHT" then y = -y - 30 elseif rt == "BOTTOMLEFT" or rt == "BOTTOM" or rt == "BOTTOMRIGHT" then  y = y + 50 end
 if rt == "TOPLEFT" or rt == "LEFT" or rt == "BOTTOMLEFT" then x = x + 20 elseif rt == "TOPRIGHT" or rt == "RIGHT" or rt == "BOTTOMRIGHT" then x = x - 20 end
 f:SetPoint(rt, x, y)

 f:SetSize(350, 15)
 f:SetOrientation("HORIZONTAL")
 
 f._EditBox = editbox
 
 f:SetMinMaxValues(min, max);
 f:SetValueStep(1);
 f.DefaultValue = default
 f:SetValue(val)
 
 _G["cfg" .. name .. "Low"]:SetText(min)
 _G["cfg" .. name .. "High"]:SetText(max)
 _G["cfg" .. name .. "Text"]:SetText(txt)

 f:SetScript("OnValueChanged", Slider_ValueChanged)

end

local function EditBox_EnterPressed(this)
 local s = mnuitems[this._Slider]
 local v = tonumber(this:GetText())
 if not v then v = 0 end
 local min, max = s:GetMinMaxValues()
 if v < min then v = min elseif v > max then v = max end
 s:SetValue(v)
 this:SetText(v)
 this:ClearFocus()
end

local function EditBox_MouseWheel(this, delta)
 local s = mnuitems[this._Slider]
 local v = tonumber(this:GetText()) + delta
 if not v then v = 0 end
 local min, max = s:GetMinMaxValues()
 if v < min then v = min elseif v > max then v = max end
 s:SetValue(v)
 this:SetText(v)
end

local function EditBox_FocusLost(this)
 SaveValues(this)
end

local function PlaceText(mnu, x, y, rt, name, txt, slider)
 local f = CreateFrame("EditBox", "cfg" .. name, mnu, "InputBoxTemplate")
 mnuitems[name] = f
 f.name = name

 f:ClearAllPoints()
 
 if rt == "TOPLEFT" or rt == "TOP" or rt == "TOPRIGHT" then y = -y - 30 elseif rt == "BOTTOMLEFT" or rt == "BOTTOM" or rt == "BOTTOMRIGHT" then  y = y + 50 end
 if rt == "TOPLEFT" or rt == "LEFT" or rt == "BOTTOMLEFT" then x = x + 20 elseif rt == "TOPRIGHT" or rt == "RIGHT" or rt == "BOTTOMRIGHT" then x = x - 20 end

 f:SetPoint(rt, x, y)
 f:SetParent(mnu)
 
 f:SetSize(40, 22)
 f:SetTextInsets(0,4,7,5)
 f._Slider = slider
 
 f:SetText(txt)

 f:SetFontObject(GameFontHighlight)
 f:SetJustifyH("CENTER")
 
 f:SetMaxLetters(5)
 
 f:SetAutoFocus(false)
 
 f:SetScript("OnEscapePressed", function(this) this:ClearFocus() end)
 f:SetScript("OnEnterPressed", EditBox_EnterPressed)
 f:SetScript("OnMouseWheel", EditBox_MouseWheel)
 f:SetScript("OnEditFocusLost", EditBox_FocusLost)
end




local function OnEventCB(self, evt, ...)
 if evt == "PLAYER_REGEN_ENABLED" then if _SavePending then SaveValues() end
 elseif evt == "PLAYER_REGEN_DISABLED" then SkyUIConfigMenu:Hide() end
end

function ConfigMenu_Loaded()
 if not evt then evt = CreateFrame("Frame")
  SkyUIConfigMenu:HookScript("OnShow",
   function(self)
    self:RegisterEvent("PLAYER_REGEN_DISABLED")
    self:RegisterEvent("PLAYER_REGEN_ENABLED")
    if not InCombatLockdown() and _SavePending then SaveValues() end
   end)
  SkyUIConfigMenu:HookScript("OnHide", function(self) self:UnregisterEvent("PLAYER_REGEN_DISABLED") self:UnregisterEvent("PLAYER_REGEN_ENABLED") end)
  SkyUIConfigMenu:SetScript("OnEvent", OnEventCB)
 end

 local mnu = SkyUIConfigMenu
 -- ui, setting
 PlaceCheckBox(cfgTab1, 0, 10, "TOPLEFT", "cHud", "Disable SkyUI Hud")

 PlaceSlider(SkyUIConfigMenu, 0, 60, "TOP", "HorzOffset", "Horizontal Offset", -400, 50, SkyUI.Config.UnitFrames.OffsetX, 0, "HorzOffsetVal")
 PlaceSlider(SkyUIConfigMenu, 0, 140, "TOP", "VertOffset", "Vertical Offset", -300, 500, SkyUI.Config.UnitFrames.OffsetY, 0, "VertOffsetVal")

 PlaceText(SkyUIConfigMenu, 0, 85, "TOP", "HorzOffsetVal", "0", "HorzOffset")
 PlaceText(SkyUIConfigMenu, 0, 165, "TOP", "VertOffsetVal", "0", "VertOffset")

 PlaceCheckBox(cfgTab1, 0, 60, "BOTTOMLEFT", "cFocus", "Focus Frame")
 PlaceCheckBox(cfgTab1, 0, 30, "BOTTOMLEFT", "cPet", "Pet Frame")
 PlaceCheckBox(cfgTab1, 0, 0, "BOTTOMLEFT", "cPetTarget", "Pet's Target Frame")

 PlaceCheckBox(cfgTab1, 150, 60, "BOTTOMLEFT", "cTargetTarget", "Target's Target Frame")
 PlaceCheckBox(cfgTab1, 150, 30, "BOTTOMLEFT", "cTargetPet", "Target's Pet Frame")
 PlaceCheckBox(cfgTab1, 150, 0, "BOTTOMLEFT", "cTargetPetTarget", "Target's Pet's Target Frame") 
 


 PlaceCheckBox(cfgTab2, 0, 10, "TOPLEFT", "cActionBars", "Disable SkyUI ActionBars")
 PlaceCheckBox(cfgTab2, 0, 0, "BOTTOMLEFT", "cMacroText", "Macro Text")
 PlaceCheckBox(cfgTab2, 0, 30, "BOTTOMLEFT", "cHotKeys", "HotKey")
 PlaceCheckBox(cfgTab2, 0, 60, "BOTTOMLEFT", "cItemCount", "Item Count")
 PlaceCheckBox(cfgTab2, 0, 90, "BOTTOMLEFT", "cGCD", "Global Cooldown")

 PlaceCheckBox(cfgTab2, 0, 65, "TOPLEFT", "cKeyPad", "KeyPad")
 PlaceCheckBox(cfgTab2, 0, 95, "TOPLEFT", "cArrowPad", "ArrowPad")
 PlaceCheckBox(cfgTab2, 0, 125, "TOPLEFT", "cVertBar", "VertBar")
 PlaceCheckBox(cfgTab2, 120, 65, "TOPLEFT", "cMainBar", "MainBar")
 PlaceCheckBox(cfgTab2, 120, 95, "TOPLEFT", "cMicroMenu", "MicroMenu")
 PlaceCheckBox(cfgTab2, 120, 125, "TOPLEFT", "cPetBar", "PetBar")

 
end

SkyUI.OnConfigLoaded = function ()
 if InCombatLockdown() then return true end
 local cfg = SkyUI.Config
 
 mnuitems.cHud:SetChecked(not cfg.UnitFrames.UI.Enabled)
 mnuitems.cActionBars:SetChecked(not cfg.ActionBars.UI.Enabled)

 mnuitems.cFocus:SetChecked(cfg.UnitFrames.focus.Enabled)
 mnuitems.cPet:SetChecked(cfg.UnitFrames.playerpet.Enabled)
 mnuitems.cPetTarget:SetChecked(cfg.UnitFrames.playerpettarget.Enabled)
 mnuitems.cTargetTarget:SetChecked(cfg.UnitFrames.targettarget.Enabled)
 mnuitems.cTargetPet:SetChecked(cfg.UnitFrames.targetpet.Enabled)
 mnuitems.cTargetPetTarget:SetChecked(cfg.UnitFrames.targetpettarget.Enabled)

 mnuitems.HorzOffset:SetValue(cfg.UnitFrames.UI.OffsetX)
 mnuitems.HorzOffsetVal:SetText(cfg.UnitFrames.UI.OffsetX)

 mnuitems.VertOffset:SetValue(cfg.UnitFrames.UI.OffsetY)
 mnuitems.VertOffsetVal:SetText(cfg.UnitFrames.UI.OffsetY)

-- print(cfg.ActionBars.UI.ItemCounts)

 mnuitems.cMacroText:SetChecked(cfg.ActionBars.UI.MacroText)
 mnuitems.cHotKeys:SetChecked(cfg.ActionBars.UI.HotKeys)
 mnuitems.cItemCount:SetChecked(cfg.ActionBars.UI.ItemCount)
 mnuitems.cGCD:SetChecked(cfg.ActionBars.UI.ShowGCD)

 mnuitems.cKeyPad:SetChecked(cfg.ActionBars.KeyPad.Enabled)
 mnuitems.cArrowPad:SetChecked(cfg.ActionBars.ArrowPad.Enabled)
 mnuitems.cVertBar:SetChecked(cfg.ActionBars.VertBar.Enabled)
 mnuitems.cMainBar:SetChecked(cfg.ActionBars.MainBar.Enabled)
 mnuitems.cMicroMenu:SetChecked(cfg.ActionBars.MicroMenu.Enabled)
 mnuitems.cPetBar:SetChecked(cfg.ActionBars.PetBar.Enabled)
 
 
 SkyUI.Modules.Main:OnConfigUpdated()
end

SLASH_SKYUI1 = "/skyui"
SlashCmdList["SKYUI"] = function(msg, editBox)
 SkyUIConfigMenu:Show()
end

SLASH_SKY1 = "/sky"
SlashCmdList["SKY"] = function(msg, editBox)
 SkyUIConfigMenu:Show()
end











